Attribute VB_Name = "ModErrShellEx"
'jmfmarques a crit :
'Allez...
'Je vais saisir cette occasion pour proposer  Bbil (s'il en est d'accord) de proposer  ma place , en contributions, un truc qui ne rpond pas directement  cel mais  plusieurs questions de cette nature poses au cours des derniers mois.
'Le fichier existe-t-il ? est-il "occup" ? peut-on le lire ? etc...
'Tu veux cel Bbil ?
' Et voil le dit code utilis dans un source
Option Explicit
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'La fonction ShellExecute ouvre ou dite le fichier spcifi.
'Ce fichier peut tre un fichier excutable ou un document.
'En cas de succs, la valeur retourne par la fonction est le handle de l'application lance
'                   ou celui de l'application DDE/serveur
'En cas d'chec, la valeur retourne par la fonction est un n d'erreur infrieur ou gal  32.
'je vous fais grce des erreurs possibles, que vous verrez plus bas (constantes auto-explicites)
'=====================================Les paramtres=============================================
'=== hwnd : spcifie le handle de la fentre parent. Cette fentre est celle qui reoit
'           les boites de message gnres par l'application (donc galement les messages d'erreur)
'=== lpOperation  : reprsente un pointeur vers une chane de caractres termine par un NULL
'                   et qui spcifie l'opration  excuter. Sont valables les chaines suivantes :
'            ---open : la fonction ouvre le fichier (qui peut tre un fichier
'                                  excutable ou un document, mais galement un rpertoire 
'                                  ouvrir), spcifi par lpfile.

'            ---print : La fonction dite le fichier spcifi par lpfile, fichier qui ne peut alors
'                qu'tre un document
'                Si toutefois, le fichier est finalement un excutable, la fonction ouvre ce
'                fichier comme si "open" avait t utilis au lieu de "Print"

'            ---Explore : la fonction explore le rpertoire spcifi par lpfile

'                 le paramtre lpOperation peut tre un NULL. Dans un tel cas, la fonction ouvre le fichier
'                 spcifi par lpfile.
'=== lpFile : reprsente un pointeur vers une chane de caractres termine par un NULL et qui
'             spcifie le fichier  ouvrir ou diter ou le rpertoire  ouvrir ou explorer.
'             La fonction peut ouvrir un excutable ou un fichier document. Elle peut diter un
'             fichier document.
'=== lpParameters : reprsente un pointeur vers une chane de caractres termine par un NULL, qui
'                   spcifie les paramtres  passer  l'application (si lpfile est un excutable
'                   uniquement)
'                   Si lpfile n'est pas un excutable, le paramtre lpParameters doit tre un NULL.
'=== lpDirectory : reprsente un pointeur vers une chane de caractres termine par un NULL et
'                  qui spcifie je rpertoire par dfaut.


'=== nShowCmd : Spcifie la faon dont l'application doit tre montre  l'ouverture, si lpfile
'               est un excutable uniquement
'               Ce pramtre peut recevoir l'une des valeurs suivantes :

' SW_HIDE (pour cacher la fentre et en activer une autre) - SW_MAXIMIZE (pour "maximiser"
'l'affichage de la fentre) - SW_MINIMIZE (pour "minimiser" l'affichage de la fentre et
'activer la fentre suivante en respectant le "zorder") - SW_RESTORE (pour activer et afficher la
'fentre. Si celle-ci est "maximise" ou "minimise", Windows la restitue dans ses dimensions et
'position d'origine. A spcifier donc pour restaurer) - SW_SHOW (pour activer la fentre et l'afficher
'dans ses dimensions et position en cours) - SW_SHOWDEFAULT (rgle l'tat d'affichage sur la base
'du flag SW_... spciifi dans la structure STARTUPINFO passe  la fonction CreateProcess
'par le programme ayant dmarr l'application. Une application doit appeler ShowWindow avec ce
'"flag" pour dfinir l'tat initial d'affichage de sa fentre principale) - SW_SHOWMAXIMIZED (pour
'activer la fentre et l'afficher  ses dimensions maximum) - SW_SHOWMINIMIZED (pour activer la
' fentre et l'afficher  ses dimensions minimum) - SW_SHOWMINNOACTIVE (pour afficher la fentre
' comme une fenpetre rduite, la fentre restant active) - SW_SHOWNA (pour afficher dans les dimensions
'position en cours, la fentre restant active) - SW_SHOWNOACTIVATE (pour afficher la fentre dans
'ses plus rcentes dimensions et position,la fentre restant active) - SW_SHOWNORMAL (pour afficher
'et activer une fentre. Si cette dernire est "maximise" ou "minimise", Windows la restaure
'dans ses dimensions et position d'origine. Une application doit spcifier ce "flag" lors du premier
'affichage d'une fentre)
'Si lpFile dsigne un fichier document, nShowCmd doit avoir la valeur 0 (zero).


Private Declare Function ShellExecuteForExplore Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, lpParameters As Any, lpDirectory As Any, ByVal nShowCmd As Long) As Long
Public Enum EShellShowConstants
     zouSW_HIDE = 0
     zouSW_MAXIMIZE = 3
     zouSW_MINIMIZE = 6
     zouSW_SHOWMAXIMIZED = 3
     zouSW_SHOWMINIMIZED = 2
     zouSW_SHOWNORMAL = 1
     zouSW_SHOWNOACTIVATE = 4
     zouSW_SHOWNA = 8
     zouSW_SHOWMINNOACTIVE = 7
     zouSW_SHOWDEFAULT = 10
     zouSW_RESTORE = 9
     zouSW_SHOW = 5
End Enum
Private Const ERROR_FILE_NOT_FOUND = 2&
Private Const ERROR_PATH_NOT_FOUND = 3&
Private Const ERROR_BAD_FORMAT = 11&
Private Const SE_ERR_ACCESSDENIED = 5           ' accs interdit
Private Const SE_ERR_ASSOCINCOMPLETE = 27
Private Const SE_ERR_DDEBUSY = 30
Private Const SE_ERR_DDEFAIL = 29
Private Const SE_ERR_DDETIMEOUT = 28
Private Const SE_ERR_DLLNOTFOUND = 32
Private Const SE_ERR_FNF = 2                     '  Fichier non trouv
Private Const SE_ERR_NOASSOC = 31
Private Const SE_ERR_PNF = 3                     '  chemin inconnu
Private Const SE_ERR_OOM = 8                     '  dpassement de mmoire
Private Const SE_ERR_SHARE = 26

Public Function ShellEx(ByVal sFile As String, _
        Optional ByVal eShowCmd As EShellShowConstants = zouSW_SHOWDEFAULT, _
        Optional ByVal sParameters As String = "", _
        Optional ByVal sDefaultDir As String = "", _
        Optional sOperation As String = "open", _
        Optional Owner As Long = 0 _
    ) As Boolean
Dim lR As Long
Dim lErr As Long, sErr As String
    If (InStr(UCase$(sFile), ".EXE") <> 0) Then
        eShowCmd = 0
    End If
    On Error Resume Next
    If (sParameters = "") And (sDefaultDir = "") Then
        lR = ShellExecuteForExplore(Owner, sOperation, sFile, 0, 0, zouSW_SHOWNORMAL)
    Else
        lR = ShellExecute(Owner, sOperation, sFile, sParameters, sDefaultDir, eShowCmd)
    End If
    'MsgBox lR
    If (lR < 0) Or (lR > 32) Then
        ShellEx = True
    Else
        lErr = vbObjectError + 1048 + lR
        Select Case lR
        Case 0
            lErr = 7: sErr = "Dpassement de mmoire"
        Case ERROR_FILE_NOT_FOUND
            lErr = 53: sErr = "Fichier non trouv"
        Case ERROR_PATH_NOT_FOUND
            lErr = 76: sErr = "Chemin inconnu"
        Case ERROR_BAD_FORMAT
            sErr = "L'excutable n'est pas valide ou est corrompu"
        Case SE_ERR_ACCESSDENIED
            lErr = 75: sErr = "Erreur/ accs au rpertoire ou au fichier"
        Case SE_ERR_ASSOCINCOMPLETE
            sErr = "Ce type de fichier est sans association valable"
        Case SE_ERR_DDEBUSY
            lErr = 285: sErr = "Le fichier n'a pu tre ouvert car en cours d'utilisation. Recommencez plus tard SVP."
        Case SE_ERR_DDEFAIL
            lErr = 285: sErr = "Le fichier n'a pu tre ouvert car la transaction DDE a failli.  Recommencez plus tard SVP."
        Case SE_ERR_DDETIMEOUT
            lErr = 286: sErr = "Le fichier n'a pu tre ouvert (dlai max dpass).  Recommencez plus tard SVP."
        Case SE_ERR_DLLNOTFOUND
            lErr = 48: sErr = "Impossible de trouver la DLL spcifie."
        Case SE_ERR_FNF
            lErr = 53: sErr = "Fichier non trouv"
        Case SE_ERR_NOASSOC
            sErr = "Aucune association dfinie pour ce type de fichier"
        Case SE_ERR_OOM
            lErr = 7: sErr = "Mmoire puise"
        Case SE_ERR_PNF
            lErr = 76: sErr = "Chemin inconnu"
        Case SE_ERR_SHARE
            lErr = 75: sErr = "Violation de partage !."
        Case Else
            sErr = "Une erreur a surgi au moment d'essayer d'ouvrir ou d'diter le fichier choisi."
        End Select
                
        MsgBox "Error n" & CStr(lErr) & Chr(13) & sErr & " sur ouverture  : " & Chr(13) & sFile, vbCritical
        ShellEx = False
    End If

End Function



